/* watch reads data from url and apends it to "el" as text */
window.watch = function(logfile, offset) {
    let el = document.getElementById("log");
    let status = document.getElementById("status");
    let scrollLock = false

    el.addEventListener("scroll", function() {
        if (el.scrollTop+el.offsetHeight >= el.scrollHeight) {
            // scrolled to the end
            scrollLock = false;
        } else {
            scrollLock = true;
        }
        // console.debug("scroll", el.scrollTop, el.offsetHeight, el.scrollTop+el.offsetHeight, el.scrollHeight, scrollLock);
    });

    el.scrollTop = el.scrollHeight

    let url = logfile+"/?raw=true"
    console.debug("watching", url, "offset", offset, "el", el);
    // Append new bytes from the log
    let append = function() {
        doXHR("GET", url+"&offset="+offset, null, {}, (xhr) => {
            if (xhr.status != 200) {
                // error getting the log, we stop the watcher
                cancel();
            }
            let bytes = xhr.responseText.length
            if (bytes > 0) {
                // console.debug("url", url, offset, "new bytes", bytes);
                offset += bytes
                el.innerText += xhr.responseText;
            }
            if (!scrollLock) {
                el.scrollTop = el.scrollHeight
            }
            // Check if backup is still running
            doXHR("GET", "fylrctl.lck/?raw=true", null, {}, (xhr) => {
                if (xhr.status != 200) {
                    // error getting the lock, we stop the watcher
                    cancel();
                    document.location.reload();
                } else {
                    window.setTimeout(append, 500)
                }
            });
        });
    }

    append();

    let cancel = function() {
        status.innerText = "Backup done";
    }
}

window.confirmRestore = function(remote) {
    return confirm("This will destroy all data on \""+remote+"\"!");
}

/* watch pase on the elemens, split and fill login password */
window.watchURLPaste = function(els) {
    for (el of els) {
        (function(el) {
            el.addEventListener("input", function(ev) {
                if (el.value == "") {
                    el.form.elements.login.value = "";
                    el.form.elements.password.value = "";
                }
            });
            el.addEventListener("paste", function(ev) {
                let paste = (ev.clipboardData || window.clipboardData).getData('text');
                let preventDefault = true
                try {
                    let url = new URL(paste);
                    console.debug("Url parsed", paste, url)
                    let login = url.searchParams.get("login")
                    let password = url.searchParams.get("password")
                    let server = url.searchParams.get("server")
                    if (login) {
                        el.form.elements.login.value = login;
                    }
                    if (password) {
                        el.form.elements.password.value = password;
                    }
                    if (server) {
                        el.value = server;
                    } else {
                        el.value = url.protocol;
                        el.value += "//";
                        if (url.username) {
                            el.value += url.username
                            if (url.password) {
                                let pw = url.password
                                if (encodeURIComponent(decodeURIComponent(pw)) != pw) {
                                    // encode if not already
                                    pw = encodeURIComponent(pw)
                                }
                                el.value += ":"+pw
                            }
                            el.value += "@"
                        }
                        el.value += url.hostname
                        if (url.port) {
                            el.value += ":"+url.port
                        }
                    }
                } catch {
                    preventDefault = false;
                }
                if (preventDefault) {
                    ev.preventDefault();
                }
                return false;
            });
        })(el)
    }
}

window.updateIndex = function() {
    console.debug("watching (every 5 seconds)", document.location.href);
    // Append new bytes from the log
    let update = function() {
        doXHR("GET",  document.location.href, null, {
        }, (xhr) => {
            let div = document.createElement("DIV")
            div.innerHTML = xhr.responseText
            // console.debug("yo", xhr, div);
            let tb = div.querySelector("#backups")
            if (!tb) {
                console.error("table #backup not found. stopping watch.");
                return
            }
            let tb_html = tb.innerHTML
            // document.getElementById("backups").innerHTML = tb_html
            // console.debug("idx", tb_html.indexOf("spinner"))

            // Update again after 5 second if we still have the loading
            // spinner inside the HTML
            if (tb_html.indexOf("spinner") > -1) {
                window.setTimeout(update, 5000);
            } else {
                console.debug("DONE watching", document.location.href);
            }
        })
    }
    update();
}